;      *******************************************************************
;           This is an example how to use CUDOBJ_T.obj in assembler.
;      *******************************************************************

EXTRN  CUD_FM_PLAYER:FAR
.386

PROGRAMM SEGMENT BYTE PUBLIC USE16 'CODE'
ASSUME CS:PROGRAMM,SS:STAC

L      macro r
xor    r,r
ENDM

STRI macro s
mov ah,9
mov dx,seg s
mov ds,dx
lea dx,s
int 21h
ENDM

MSS0          db 13,10,"www.urbanbytes.de",13,10,"$"
MSS2          db 13,10,"ADLIB-card not found !",13,10,"$"

 
START:
 

              mov    ah,1
              call   CUD_FM_PLAYER
              jc     ERR_1


              mov    ah,2
              mov    si,seg SONG
              mov    ds,si
              lea    si,SONG
              call   CUD_FM_PLAYER
              jc     ERR_2
              stri   MSS0

              mov    ax,sons
              mov    ds,ax
              lea    si,image
              mov    ax,0b800h
              mov    es,ax
              l      di
              mov    cx,4000/4
              rep    movsd

              mov    dx,3c8h
              mov    ax,1
              out    dx,al
              inc    dx
              mov    al,5
              out    dx,al
              mov    al,10
              out    dx,al
              mov    al,15
              out    dx,al


              l      ax
              int    16h

              mov    ah,3
              call   CUD_FM_PLAYER
              stri   MSS0

              mov    ax,4C00h
              int    21h
ERR_1:        stri   MSS2
              mov    ax,4C01h
              int    21h
ERR_2:        stri   MSS0
              mov    ax,4C02h
              int    21h
 
 
ENDS

SONS SEGMENT PARA USE16 'DATA'
       include       song.asm
       include       image.asm
SONS ENDS

STAC SEGMENT para STACK use16 'STACK'
       org 256
STAC ENDS

END START