.486

PROGRAMM SEGMENT PARA PUBLIC USE32
	assume	cs:PROGRAMM,ds:PROGRAMM

include pmprg.inc

L macro x
xor x,x
endm

RLA macro
LOCAL Rueck1,Rueck2
push edx
push eax
	 mov dx,3dah
Rueck1:  in al,dx
	 and al,8
	 jne Rueck1

Rueck2:  in al,dx
	 and al,8
	 je Rueck2
pop eax
pop edx
endm

LASI macro v
lea esi,v
endm

LADI macro v
lea edi,v
endm

oldint8	dd	?

public FM_START,FM_STOP,FM_RESET

PATTERNSIZE   = 1728

 
CUDSEG        dw ?
FM_PLAYING    db ?
FM_COUNT      dw ?
FM_ROW        db ?
FM_PATTERN    db ?
FM_TRACK      db ?
FM_REPEAT     db ?
FM_PEEK       db ?,?,?,?,?,?,?,?,?
FM_NOTE       db ?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?
CHN_OFF       db ?,?,?,?,?,?,?,?,? 
FH            dw ?
LOADED        db ?
SONGOFF       dd ?
CA0           db 0 
CB0           db 0 
FMPORT        =  388h
TEMPO         db 07dh/2
SPEED         db 6
SPEEDC        db 2
	 
 
 
; ah=WERT al=REG
FM:    push   ecx edx 
	mov    dx,FMPORT
	out    dx,al
	mov    ecx,6
LMYF:  in     al,dx 
	loop   LMYF
	inc    dx
	mov    al,ah
	out    dx,al
	dec    dx
	mov    ecx,30
KMSM:  in     al,dx
	loop   KMSM
	pop    edx ecx
	ret
 
 
FM_RESET:     mov    ax,6004h
		call   FM
		mov    ax,8004h
		call   FM
		mov    dx,FMPORT
		in     al,dx
		mov    bp,ax
		mov    ax,0ff02h
		call   FM
		mov    ax,2104h
		call   FM
		rla
		rla
		mov    dx,FMPORT
		in     al,dx
		push   eax
		mov    ax,6004h
		call   FM
		mov    ax,8004h
		call   FM
		pop    eax
		and    al,0e0h
		cmp    al,0c0h
		jne    NOFM
		mov    ax,bp
		and    al,0e0h
		jne    NOFM

		mov    ax,2001h      ; Reset und Verzerrungen an...
		call   FM
		mov    ax,8          ; CSM-Mode off & Keyboardsplit off
		call   FM
		mov    ax,00BDh      ; kein Schlagzeugmodus & Vibratos einstellen
		call   FM
		
		lasi   CHN1
		mov    dx,9
		mov    bl,0b0h
YYDF:         mov    ecx,14
DHGG:         mov    al,ds:[esi]
		add    si,2
		mov    ah,-1
		call   FM
		loop   DHGG
		mov    al,bl
		l      ah
		call   FM
		inc    bl
		add    si,4
		dec    dx
		jne    YYDF
		clc
		ret
NOFM:         stc 
		ret
 
 
;      CX=TEMPO 
SET_TEMPO:    push   edx
		or     cx,cx
		jne    SLXJ
		l      ax
		jmp    POAS
SLXJ:         mov    al,36h
		out    43h,al
		l      edx
		mov    eax,1412926;1192755
		and    ecx,0ffffh
		div    ecx
POAS:         out    40h,al
		mov    al,ah
		out    40h,al
		pop    edx
		ret
 
 
FM_STOP:      cmp    FM_PLAYING,0
		je     IDGP
		l      cx
		call   SET_TEMPO
		call   DELINT8
		mov    FM_PLAYING,0
		mov    FM_COUNT,0
		mov    SPEED,6
		mov    SPEEDC,6
		mov    TEMPO,62
		call   FM_RESET
		ret
IDGP:         stc
		ret
 
 
SONG_PROC:    mov    ds,CUDSEG
		call   POSITIONS
		call   SPIELE_ROW
		ret
 
 
POSITIONS:    mov    ax,FM_COUNT
		;cmp    ax,1
		;je     ende

		and    ax,00111111b
		jne    NONEWPATTERN
		
		movzx  ebx,FM_COUNT
		shr    ebx,6
		mov    FM_PATTERN,bl
		add    ebx,SONGOFF
		mov    al,ds:[ebx+1576]
		or     al,al
		jns    SLXI
		mov    FM_COUNT,0
		inc    FM_REPEAT

		mov    FM_PATTERN,0
		mov    esi,SONGOFF
		add    esi,1576
		mov    al,ds:[esi]
SLXI:         mov    FM_TRACK,al

NONEWPATTERN: mov    ax,FM_COUNT
		and    ax,63
		mov    FM_ROW,al
		inc    FM_COUNT
		ret
 
 
; al=nr of Instr
; bl=nr of Channel
INS2CHN:      and    eax,255
		shl    eax,5
		mov    esi,SONGOFF
		mov    ds,CUDSEG
		add    esi,eax
		ladi   CHN1
		and    ebx,255
		shl    ebx,5
		add    edi,ebx
		mov    es:[edi+27],b 0
		mov    ecx,11
		add    edi,2
DFCL:         inc    edi
		movsb
		loop   DFCL
		ret
 
 
LOAD_INSTRUMENTS:    ladi   CHN1
		mov    esi,SONGOFF
		mov    ds,CUDSEG
		mov    dx,9
XUNK:         push   edi esi
		add    edi,2
		mov    ecx,11
BUNK:         inc    edi
		movsb
		loop   BUNK
		pop    esi edi
		add    esi,32
		add    edi,32
		dec    dx
		jne    XUNK
		ret
 
 
SPIELE_ROW:   mov    ds,CUDSEG
		mov    esi,SONGOFF
		add    esi,1641
		
		movzx  ax,FM_TRACK
		mov    bx,PATTERNSIZE
		mul    bx
		and    eax,65535
		add    esi,eax
		movzx  ax,FM_ROW
		mov    bx,PATTERNSIZE/64
		mul    bx
		add    esi,eax
		
		ladi   CHN1
		mov    edx,9
NEXTCH:       mov    ebx,9
		sub    ebx,edx
		cmp    ds:[CHN_OFF+ebx],0
		jne    PAUSE       
		cmp    ds:[esi+1],b 0
		je     NOPREF
		cmp    ds:[esi+1],b "I"      ; NEW INSTRUMENT
		jne    NONINS
		mov    bl,9
		sub    bl,dl
		mov    al,ds:[esi+2]
		pushad
		push   ds es
		call   INS2CHN
		pop    es ds
		popad
		jmp    NOPREF
NONINS:       cmp    ds:[esi+1],b "H"      ; NEW TEMPO            
		jne    NONTEM
		movzx  cx,ds:[esi+2]
		cmp    cx,21
		ja     SOPJ
		mov    cx,7dh
SOPJ:         shr    cx,1
		call   SET_TEMPO
		jmp    NOPREF
NONTEM:       cmp    ds:[esi+1],b "A"      ; NEW SPEED
		jne    NONSPD
		mov    al,ds:[esi+2]
		or     al,al       
		je     NOPREF
		mov    SPEED,al
		mov    SPEEDC,al
		jmp    NOPREF
NONSPD:       cmp    ds:[esi+1],b "L"      ; NEXT PATTERN
		jne    NOJMPP
		mov    ax,FM_COUNT
		and    ax,63
		mov    cx,64
		sub    cx,ax
		add    FM_COUNT,cx
		movzx  cx,ds:[esi+2]
		add    FM_COUNT,cx
		jmp    NOPREF
NOJMPP:       cmp    ds:[esi+1],b "K"      ; JUMP TO ORDER
		jne    NOJMPO
		cmp    b ds:[esi+2],63
		jbe    ZVLK
		mov    b ds:[esi+2],63
ZVLK:         movzx  ax,b ds:[esi+2]  
		shl    ax,6
		mov    FM_COUNT,ax
		jmp    NOPREF
NOJMPO:       cmp    ds:[esi+1],b "M"      ; SET VIBRATO
		jne    NOVIB 
		l      ah
		test   ds:[esi+2],b 0f0h
		je     IPOE
		or     ah,10000000b
ipoe:         test   ds:[esi+2],b 0fh
		je     IPOT
		or     ah,01000000b
ipot:         mov    al,0bdh
		call   FM
		jmp    NOPREF
		
		
		jmp    NOPREF
NOVIB: 

NOPREF:       mov    al,ds:[esi]
		cmp    al,109
		jne    NOPAUSE
PAUSE:        and    es:[edi+27],b 11011111b
		mov    ah,es:[edi+27]
		mov    al,es:[edi+26]
		call   FM
		jmp    NONEWN
NOPAUSE:      or     al,al
		jz     NONEWN
		mov    es:[edi+28],al
		l      ebx
		mov    bl,al
		shl    bx,1
		mov    al,[NOTENW+ebx]
		mov    es:[edi+25],al
		mov    al,[NOTENW+ebx+1]
		mov    es:[edi+27],al
		mov    ebx,9
		sub    ebx,edx
		mov    ds:[FM_PEEK+ebx],b -1
OKSE:         call   SENDE_FM
NONEWN:       
		mov    ebx,9
		sub    ebx,edx
		mov    ax,ds:[esi]
		mov    ecx,ebx
		shl    ecx,1
		add    ebx,ecx
		mov    w ds:[FM_NOTE+ebx],ax   
		mov    al,ds:[esi+2]
		mov    ds:[FM_NOTE+ebx+2],al   
		
		cmp    ds:[esi+1],b 0        ; Zweite Effekte
		je     NOEFF
		cmp    ds:[esi+1],b "C"
		jne    NOSMV
		mov    al,ds:[esi+2]
		mov    es:[edi+9],al
		jmp    FUSJ
NOSMV:        cmp    ds:[esi+1],b "G"
		jne    NOSCV
		mov    al,ds:[esi+2]
		mov    es:[edi+7],al
		jmp    FUSJ
NOSCV:        cmp    ds:[esi+1],b "B"
		jne    NOSVV
		mov    cl,ds:[esi+2]
		mov    es:[edi+21],cl
		jmp    FUSJ
NOSVV:        cmp    ds:[esi+1],b "E"
		jne    NOPSL
		movzx  cx,es:[edi+30]
		mov    al,es:[edi+25]
		mov    ah,es:[edi+27]
		mov    bl,ah
		and    ah,3
		sub    ax,cx
		mov    es:[edi+25],al
		and    bl,11111100b
		add    ah,bl
		mov    es:[edi+27],ah
		call   SENDE_FM3
		jmp    OBBO
NOPSL:        cmp    ds:[esi+1],b "F"
		jne    NOPSH
		movzx  cx,es:[edi+30]
		mov    al,es:[edi+25]
		mov    ah,es:[edi+27]
		mov    bl,ah
		and    ah,3
		add    ax,cx
		mov    es:[edi+25],al
		and    bl,11111100b
		add    ah,bl
		mov    es:[edi+27],ah
		call   SENDE_FM3
		jmp    OBBO
NOPSH:        cmp    ds:[esi+1],b "D"
		jne    NOPSV
		mov    al,b es:[edi+30]
		test   al,00001111b
		jne    VSLIDEUP
		shr    al,4 
		sub    es:[edi+7],al
		jnc    SOKO
		mov    b es:[edi+7],0h
SOKO:         mov    al,es:[edi+6]
		mov    ah,es:[edi+7]
		call   FM
		jmp    OBBO
VSLIDEUP:     and    al,15
		add    es:[edi+7],al
		cmp    b es:[edi+7],63
		jb     SOK2
		mov    b es:[edi+7],63     
SOK2:         mov    al,es:[edi+6]
		mov    ah,es:[edi+7]
		call   FM
		jmp    OBBO
NOPSV:
FUSJ:         call   SENDE_FM2
OBBO:         cmp    ds:[esi+2],b 0
		je     NOEFF;NSNE
		mov    al,ds:[esi+2]
		mov    es:[edi+30],al
NOEFF:        mov    al,ds:[esi+1]
		mov    es:[edi+29],al
NSNE:

SKIPCHN:      add    edi,32
		add    esi,3
		dec    edx
		jne    NEXTCH
		
		ret
 
 
SENDE_FM:     push   ecx
		l      ebp
		mov    ecx,14
OAKJ:         mov    al,es:[edi+ebp]
		mov    ah,es:[edi+ebp+1]
		add    ebp,2
		call   FM
		loop   OAKJ
		pop    ecx
		ret
 
 
SENDE_FM2:    push   ecx
		mov    ebp,2
		mov    ecx,11
OAKT:         mov    al,es:[edi+ebp]
		mov    ah,es:[edi+ebp+1]
		add    ebp,2
		call   FM
		loop   OAKT
		pop    ecx
		ret
 
 
SENDE_FM3:    mov    al,es:[edi+24]
		mov    ah,es:[edi+25]
		call   FM
		mov    al,es:[edi+26]
		mov    ah,es:[edi+27]
		call   FM
		ret
 
 
DO_EFFECTS:   mov    CB0,0b0h
		mov    CA0,0a0h
		ladi   CHN1
		l      edx
NEFC:         mov    ebx,edx
		cmp    [CHN_OFF+ebx],1
		je     NOEF2
		cmp    es:[edi+29],b 0 
		je     NOEF2
		cmp    es:[edi+29],b "J"
		jne    NOAP
		cmp    es:[edi+31],b 0
		jne    AP1
		  l    ebx
		  mov    bl,es:[edi+28]
		  shl    bx,1
		  mov    ah,ds:[NOTENW+ebx]
		  mov    al,CA0
		  call   FM
		  mov    ah,ds:[NOTENW+ebx+1]
		  mov    al,CB0
		  call   FM
		  inc    b es:[edi+31]
		  jmp    APE
AP1:          cmp    es:[edi+31],b 1
		jne    AP2
		  l      ebx
		  mov    bl,es:[edi+28]
		  mov    al,es:[edi+30]
		  shr    al,4
		  add    bl,al
		  shl    ebx,1
		  mov    ah,ds:[NOTENW+ebx]
		  mov    al,CA0
		  call   FM
		  mov    ah,ds:[NOTENW+ebx+1]
		  mov    al,CB0
		  call   FM
		  inc    b es:[edi+31]
		  jmp    APE
AP2:            l      ebx
		  mov    bl,es:[edi+28]
		  mov    al,es:[edi+30]
		  and    al,15
		  add    bl,al
		  shl    bx,1
		  mov    ah,ds:[NOTENW+ebx]
		  mov    al,CA0
		  call   FM
		  mov    ah,ds:[NOTENW+ebx+1]
		  mov    al,CB0
		  call   FM
		  mov    b es:[edi+31],0
APE:            
NOAP:
NOEF2:        inc    CA0
		inc    CB0
		add    edi,32
		inc    edx
		cmp    edx,9
		jne    NEFC
		ret
 
 
;Eingabe:
;             DS:ESI = SONGDATA
 
FM_START:     push   eax
		push   ebx
		cmp    ds:[esi],"DUC<"
		jne    CSOP
		cmp    ds:[esi+4],"-MF-"
		jne    CSOP
		cmp    ds:[esi+13h],b 0
		jne    CSOP

		add    esi,32
		mov    SONGOFF,esi
		mov    ax,ds
		mov    CUDSEG,ax
		
	    
		cmp    ds:[esi+1576],b 0ffh
		je     SXOO
		cmp    FM_PLAYING,1
		je     SXOO
		call   FM_RESET
		movzx  cx,TEMPO
		call   SET_TEMPO

		pop    ebx
		or     bl,bl
		jne    JKXN
		call   SETINT8
		jmp    LKSM
JKXN:         call   SETINT8_
LKSM:
		mov    FM_PLAYING,1
		call   LOAD_INSTRUMENTS
SXOO:         pop    eax
		clc
		ret
CSOP:         pop    eax
		stc
		ret
 
 
DELINT8:      cli
		mov    al,1
		l      bl
		mov    edx,OLDINT8
		call   [IRQlib]
		sti
		ret 
 
 
SETINT8:      cli
		l      al
		mov    bl,al
		call   [IRQlib]
		mov    OLDINT8,edx
		mov    al,1
		l      bl
		lea    edx,FM_TIMER
		add    edx,trans
		call   [IRQlib]
		sti
		ret
 
 
SETINT8_:     cli
		l      al
		mov    bl,al
		call   [IRQlib]
		mov    OLDINT8,edx
		mov    al,1
		l      bl
		lea    edx,FM_TIMER_
		add    edx,trans
		call   [IRQlib]
		sti
		ret
 
 
FM_TIMER:     push   es ds
		pusha
		mov	ds,cs:[0]
		mov	es,cs:[0]

		cmp    FM_PLAYING,1
		jne    LSDR
		dec    SPEEDC
		jne    KXJD
		mov    al,SPEED
		mov    SPEEDC,al
		call   SONG_PROC
KXJD:         call   DO_EFFECTS
LSDR:         cli
		mov    al,20h
		out    20h,al
		popa
		pop    ds es
		iretd
 
 
DO_SO         db 1
DO_EF         db 1
FM_TIMER_:    push   es ds
		pusha
		mov	ds,cs:[0]
		mov	es,cs:[0]

		cmp    FM_PLAYING,1
		jne    LSD2
		dec    SPEEDC
		jne    KXJ2
		mov    al,SPEED
		mov    SPEEDC,al
		mov    DO_SO,1
KXJ2:         mov    DO_EF,1
LSD2:         mov    al,20h
		out    20h,al
		popa
		pop    ds es     
		iretd
 
 
FM_POLL:
		cmp    DO_SO,0
		je     LDXW
		call   SONG_PROC
		mov    DO_SO,0
LDXW:
		cmp    DO_EF,0
		je     LDX2
		call   DO_EFFECTS
		mov    DO_EF,0
LDX2:
		ret
 
 


NOTENw db  0,0   ; Werte fr Register A0-A8 & B0-B8
	db  107,033,129,033,152,033,176,033,202,033,229,033,002,034,032,034
	db  065,034,099,034,135,034,174,034,107,037,129,037,152,037,176,037
	db  202,037,229,037,002,038,032,038,065,038,099,038,135,038,174,038
	db  107,041,129,041,152,041,176,041,202,041,229,041,002,042,032,042
	db  065,042,099,042,135,042,174,042,107,045,129,045,152,045,176,045
	db  202,045,229,045,002,046,032,046,065,046,099,046,135,046,174,046
	db  107,049,129,049,152,049,176,049,202,049,229,049,002,050,032,050
	db  065,050,099,050,135,050,174,050,107,053,129,053,152,053,176,053
	db  202,053,229,053,002,054,032,054,065,054,099,054,135,054,174,054
	db  107,057,129,057,152,057,176,057,202,057,229,057,002,058,032,058
	db  065,058,099,058,135,058,174,058,107,061,129,061,152,061,176,061
	db  202,061,229,061,002,062,032,062,065,062,099,062,135,062,174,062                                
															  ; Note/Effekt/Parameter  ARPEGGIO-COUNTER
CHNSIZE = 32                                                                                                            
CHN1   db  0b0h,0,23h,0,20h,0, 043h,0,40h,0, 63h,0,60h,0, 83h,0,80h,0, 0c0h,0, 0e3h,0,0e0h,0, 0a0h,0,0b0h,0  ,0    ,0      ,0               ,0
CHN2   db  0b1h,0,24h,0,21h,0, 044h,0,41h,0, 64h,0,61h,0, 84h,0,81h,0, 0c1h,0, 0e4h,0,0e1h,0, 0a1h,0,0b1h,0  ,0    ,0      ,0               ,0
CHN3   db  0b2h,0,25h,0,22h,0, 045h,0,42h,0, 65h,0,62h,0, 85h,0,82h,0, 0c2h,0, 0e5h,0,0e2h,0, 0a2h,0,0b2h,0  ,0    ,0      ,0               ,0
CHN4   db  0b3h,0,2bh,0,28h,0, 04bh,0,48h,0, 6bh,0,68h,0, 8bh,0,88h,0, 0c3h,0, 0ebh,0,0e8h,0, 0a3h,0,0b3h,0  ,0    ,0      ,0               ,0
CHN5   db  0b4h,0,2ch,0,29h,0, 04ch,0,49h,0, 6ch,0,69h,0, 8ch,0,89h,0, 0c4h,0, 0ech,0,0e9h,0, 0a4h,0,0b4h,0  ,0    ,0      ,0               ,0
CHN6   db  0b5h,0,2dh,0,2ah,0, 04dh,0,4ah,0, 6dh,0,6ah,0, 8dh,0,8ah,0, 0c5h,0, 0edh,0,0eah,0, 0a5h,0,0b5h,0  ,0    ,0      ,0               ,0
CHN7   db  0b6h,0,33h,0,30h,0, 053h,0,50h,0, 73h,0,70h,0, 93h,0,90h,0, 0c6h,0, 0f3h,0,0f0h,0, 0a6h,0,0b6h,0  ,0    ,0      ,0               ,0
CHN8   db  0b7h,0,34h,0,31h,0, 054h,0,51h,0, 74h,0,71h,0, 94h,0,91h,0, 0c7h,0, 0f4h,0,0f1h,0, 0a7h,0,0b7h,0  ,0    ,0      ,0               ,0
CHN9   db  0b8h,0,35h,0,32h,0, 055h,0,52h,0, 75h,0,72h,0, 95h,0,92h,0, 0c8h,0, 0f5h,0,0f2h,0, 0a8h,0,0b8h,0  ,0    ,0      ,0               ,0

PROGRAMM ENDS

END
