;      *******************************************************************
;            This is an example how to use CUDOBJ.obj in assembler.
;      *******************************************************************

EXTRN  CUD_FM_PLAYER:FAR
.386

PROGRAMM SEGMENT BYTE PUBLIC USE16 'CODE'
ASSUME CS:PROGRAMM,SS:STAC

L      macro r
xor    r,r
ENDM

STRI macro s
mov ah,9
mov dx,seg s
mov ds,dx
lea dx,s
int 21h
ENDM

MSS0          db 13,10,"CFF-SONG PLAYING...",13,10,"$"
MSS1          db 13,10,"CFF-SONG STOPED...",13,10,"$"
MSS2          db 13,10,"ADLIB-card not found !",13,10,"$"
MSS3          db 13,10,"Error with loading song !",13,10,"$"
FILE          db "raid.cff",0

 
START:
 

              mov    ah,1
              call   CUD_FM_PLAYER
              jc     ERR_1
              
              l      ax
              push   cs
              pop    ds
              lea    dx,FILE
              mov    bx,WORK
              mov    es,bx
              call   CUD_FM_PLAYER
              jc     ERR_2

              mov    ah,2
              call   CUD_FM_PLAYER
              stri   MSS0

              l      ax
              int    16h

              mov    ah,3
              call   CUD_FM_PLAYER
              stri   MSS1

              mov    ax,4C00h
              int    21h
ERR_1:        stri   MSS2
              mov    ax,4C01h
              int    21h
ERR_2:        stri   MSS3
              mov    ax,4C02h
              int    21h
 
 
ENDS

WORK SEGMENT PARA USE16 'DATA'
       db 65536 dup (?)
WORK ENDS

STAC SEGMENT para STACK use16 'STACK'
       org 1024
STAC ENDS

END START
